<?php
/**
 * 仓库预占流水
 * 
 * @access public
 * @author wangbiao<wangbiao@shopex.cn>
 */
class console_ctl_admin_stock_freeze extends desktop_controller{
    
    var $workground = "console_center";
    
    function index()
    {
        $this->title = '预占流水列表';
        $filter      = array();
        
        //店铺
        $shop_id    = trim($_POST['shop_id']);
        if($shop_id)
        {
            $filter['shop_id']    = $shop_id;
        }
        
        //仓库
        $branch_id    = intval($_POST['branch_id']);
        if($branch_id)
        {
            $filter['branch_id']    = $branch_id;
        }
        
        //对象类型
        $obj_type    = intval($_POST['obj_type']);
        if($obj_type)
        {
            $filter['obj_type']    = $obj_type;
        }
        
        //业务类型
        if($obj_type == 2)
        {
            $bill_type    = intval($_POST['bill_type']);
            if($bill_type)
            {
                $filter['bill_type']    = $bill_type;
            }
        }
        else 
        {
            unset($_POST['bill_type']);
        }
        
        //基础物料
        $material_bn    = trim($_POST['material_bn']);
        if($material_bn)
        {
            $mdlMaterialBasicMaterial    = app::get('material')->model('basic_material');
            $tempInfo    = $mdlMaterialBasicMaterial->dump(array('material_bn'=>$material_bn), 'bm_id');
            $filter['bm_id']    = intval($tempInfo['bm_id']);
        }
        
        //params
        $params = array(
                'title'=>$this->title,
                'use_buildin_set_tag'=>false,
                'use_buildin_filter'=>true,
                'use_buildin_export'=>false,
                'use_buildin_import'=>false,
                'use_buildin_recycle'=>false,
                'actions'=>array(),
                'base_filter' => $filter,
        );
        
        //top filter
        if(!isset($_GET['action'])) {
            $panel = new desktop_panel($this);
            $panel->setId('stock_freeze_finder_top');
            $panel->setTmpl('admin/finder/stock_freeze_top_filter.html');
            $panel->show('console_mdl_basic_material_stock_freeze', $params);
        }
        
        $this->finder('console_mdl_basic_material_stock_freeze', $params);
    }
    
    //加载业务类型
    function ajax_bmsq_type()
    {
        $obj_type    = $_POST['obj_type'];
        if(empty($obj_type))
        {
            echo json_encode(array('res'=>'error'));
            exit;
        }
        
        $stockFreezeObj    = app::get('console')->model('basic_material_stock_freeze');
        $typeList          = $stockFreezeObj->get_type();
        
        $html	= '<select type="select" name="bill_type" id="bill_type" class="x-input-select inputstyle"><option value=""></option>';
        if($typeList[$obj_type])
        {
            foreach ($typeList[$obj_type] as $key => $val)
            {
                $html    .= '<option value="'. $key .'">'. $val .'</option>';
            }
        }
        $html    .= '</select>';
        
        echo json_encode(array('res'=>'succ', 'html'=>$html));
        exit;
    }
}
?>