<?php
class erpapi_hchsafe_matrix_360buy_request_hchsafe extends erpapi_hchsafe_request_hchsafe{

    /**
     * 登录日志
     *
     * @return void
     * @author 
     **/
    public function login($sdf)
    {
        if (!$this->__is_config_mq()) return $this->succ();

        $jd_shop = $this->getShop();

        if (!$jd_shop['node_id']) return $this->succ();
        $title = '京东安全规范日志-登录';

        
        $pushData = array(
            'account'       =>  (string)$sdf['uname'],  # 商家操作账号
            'clientIp'      =>  $this->__remote_addr,  # 商家操作的客户端IP
            'op_time'       =>  time(),  # 商家操作时间
            'op_content'    =>  '商家登录ERP系统'.($_SESSION['last_error'] ? '失败' : '成功'),  # 商家操作内容
            'req_jos_url'   =>  $this->__url,  # ISV的操作请求URL
            'touch_num'     =>  'NULL',  # 操作涉及的订单编号
            'touch_field'   =>  'NULL',  # I操作涉及的订单字段
            'to_node_id'    =>  $jd_shop['node_id'],
        );
        
        $rs = $this->__caller->call(HCHSAFE_JD_ADDISVLOG,$pushData,array(),$title,10);
        
        return $this->succ();
    }

    public function orderdata($sdf)
    {
        
        if (!$this->__is_config_mq()) return $this->succ();

        $jd_shop = $this->getShop();
        
        if (!$jd_shop['node_id']) return $this->succ();

        $title = '京东安全规范日志-订单访问';

        
        $pushData = array(
            'account'       =>  $this->__account,  # 商家操作账号
            'clientIp'      =>  $this->__remote_addr,  # 商家操作的客户端IP
            'op_time'       =>  time(),  # 商家操作时间
            'op_content'    =>  $sdf['operation'],
            'req_jos_url'   =>  $this->__url,  # ISV的操作请求URL
            'touch_num'     =>  implode(',',(array)$sdf['tradeIds']),  # 操作涉及的订单编号
            'touch_field'   =>  'order_bn',  # I操作涉及的订单字段
            'to_node_id'    =>  $jd_shop['node_id'],
        );
        $rs = $this->__caller->call(HCHSAFE_JD_ADDISVLOG,$pushData,array(),$title,10);

        return $this->succ();
    }

    public function orderpush($sdf)
    {
        if (!$this->__is_config_mq()) return $this->succ();

        if (!$jd_shop['node_id']) return $this->succ();

        $title = '京东安全规范日志-订单推送第三方';

        $pushData = array(
            'account'       =>  $this->__account,  # 商家操作账号
            'clientIp'      =>  $this->__remote_addr,  # 商家操作的客户端IP
            'op_time'       =>  time(),  # 商家操作时间
            'op_content'    =>  '订单推送第三方',
            'req_jos_url'   =>  $this->__url,  # ISV的操作请求URL
            'touch_num'     =>  implode(',',(array)$sdf['tradeIds']),  # 操作涉及的订单编号
            'touch_field'   =>  'order_bn',  # I操作涉及的订单字段
            'to_node_id'    =>  $jd_shop['node_id'],
        );
        

        $rs = $this->__caller->call(HCHSAFE_JD_ADDISVLOG,$pushData,array(),$title,10);

        return $this->succ();
    }

    public function getShop(){

        $jd_shop = app::get('ome')->model('shop')->dump(array('node_type'=>'360buy','filter_sql'=>'(node_id!="" AND node_id is not null)'),'node_id');
        return $jd_shop;
    }
}
