<?php
class ome_batch_order{

    function getBranchStore($order_id,$branch_id)
    {
        $basicMStockFreezeLib  = kernel::single('material_basic_material_stock_freeze');
        
        $groupStore = array();
        $items = app::get('ome')->model('order_items')->getList('*', array('order_id' => $order_id, 'delete' => 'false'));
        foreach ($items as $item ) {

            if (in_array($item['product_id'], $groupStore['pids'])) {

                $groupStore['store'][$item['product_id']] += $item['nums'];
            } else {
    
                $groupStore['pids'][] = $item['product_id'];
                $groupStore['store'][$item['product_id']] = $item['nums'];
            }
        }
        $sql = "SELECT product_id, branch_id, store FROM sdb_ome_branch_product WHERE product_id in (".join(',', $groupStore['pids']).") AND branch_id IN (".$branch_id.")";
        $prows = kernel::database()->select($sql);
        
        //转换数据格式
        $store = array();
        if($prows)
        {
            $tempData    = array();
            foreach ((array) $prows as $row) {
                $product_id    = $row['product_id'];
                
                //根据仓库ID、基础物料ID获取该物料仓库级的预占
                $store_freeze    = $basicMStockFreezeLib->getBranchFreeze($row['product_id'], $row['branch_id']);
                $row['store']    = ($row['store'] < $store_freeze) ? 0 : ($row['store'] - $store_freeze);
                
                if($tempData[$product_id])
                {
                    $tempData[$product_id]['store'] += $row['store'];
                }
                else
                {
                    $tempData[$product_id] = $row;
                }
            }
            
            $store    = $tempData;
            unset($tempData);
        }
        
        //foreach ((array) $prows as $row) {
        //    $store[$row['product_id']] = $row;
        //}

        //检查订单组内的货品数量是否足够
        $allow = true;
        foreach ($groupStore['store'] as $pid => $nums) {
            if (($store[$pid]['store'] - $nums) <0) {

                $allow = false;
            } 
        }
        return $allow;
    }

    
    /**
     * 判断到不到
     * @
     * @
     * @access  public
     * @author sunjing@shopex.cn
     */
    function get_arrived($order,$corps)
    {
        $arrived_conf = app::get('ome')->getConf('ome.logi.arrived');
        $arrived_auto_conf = app::get('ome')->getConf('ome.logi.arrived.auto');
        $arrivedObj = kernel::single('omeauto_auto_plugin_arrived');
        $allow = true;
        $checkCorp = $arrivedObj->getCheckCorp();
        if ($arrived_conf=='1' && $arrived_auto_conf=='1') {
            $area = $order['ship_area'];
            $addr = $order['ship_addr'];
            $corp_id = $corps['corp_id'];

            $arrivedObj->setAddress($area,$addr);
            $arrivedObj->corp=$corps['type'];

            if (!in_array($arrivedObj->corp,$checkCorp)) {
                return true;
            }
            $result = $arrivedObj->request();

            if(empty($result)) {
                $allow = false;
            }
            if (in_array($result,array('0','2','3'))) {
                $allow = false;
                
            }
        }
        return $allow;
    }


}

?>