<?php
/**
* 仓库类
*
* @copyright shopex.cn 2013.4.10
* @author dongqiujin<123517746@qq.com>
*/
class ome_branch{

    /**
    * 获取仓库所关联的WMS
    *
    * @access public
    * @param String $branch_bn 仓库编号
    * @return String wms_id
    */
    public function getWmsId($branch_bn=''){
        $branchMdl = app::get('ome')->model('branch');
        $branch = $branchMdl->db->selectRow("select wms_id from sdb_ome_branch WHERE branch_bn='$branch_bn'");
        return isset($branch) ? $branch['wms_id'] : '';
    }

    /**
    * 获取WMS渠道列表
    *
    * @access public
    * @return Array
    */
    public function getWmsChannelList(){
        return kernel::single('channel_func')->getWmsChannelList();
    }

    /**
     *
     * 获取绑定过仓储类型的仓库列表
     * @access public
     * @return Array
     */
    public function getBindWmsBranchList(){
        $branchMdl = app::get('ome')->model('branch');
        $branch = $branchMdl->db->select("select * from sdb_ome_branch where wms_id > 0");
        return isset($branch) ? $branch : '';
    }

    /**
     *
     * 根据仓库ID获取仓库编码BN
     * @param string $branch_id 仓库ID
     * @return string $branch_bn 仓库编号
     */
    public function getBranchBnById($branch_id){
        $branchMdl = app::get('ome')->model('branch');
        $branch = $branchMdl->db->selectrow("select branch_bn from sdb_ome_branch WHERE branch_id=".$branch_id);
        return isset($branch) ? $branch['branch_bn'] : '';
    }

    /**
     *
     * 根据仓库ID获取仓库编码BN
     * @param string $branch_id 仓库ID
     * @return string $wms_id 仓库类型ID
     */
    public function getWmsIdById($branch_id){
        $branchMdl = app::get('ome')->model('branch');
        $branch = $branchMdl->db->selectrow("select wms_id from sdb_ome_branch WHERE branch_id=".$branch_id);
        return isset($branch) ? $branch['wms_id'] : '';
    }

    
    /**
     * 根据仓库ID返回节点类型.
     * @param
     * @return
     * @access  public
     * @author sunjing@shopex.cn
     */
    function getNodetypBybranchId($branch_id)
    {

        $wms_id = $this->getWmsIdById($branch_id);

        $channel_adapter = app::get('channel')->model('channel');
        $detail = $channel_adapter->dump(array('channel_id'=>$wms_id),'node_type');
        
        return $detail['node_type'];
    }

    /**
     *
     * 判断仓库是否是门店关联线下仓
     * @param string $branch_id 仓库ID
     * @return boolean true/false
     */
    function isStoreBranch($branch_id){
        $branchObj = app::get('ome')->model('branch');
        
        //filter条件中加载了权限判断,修改为SQL语句读取
        $row    = $branchObj->db->selectrow("SELECT branch_id FROM sdb_ome_branch WHERE branch_id=". $branch_id ." AND b_type=2");
        //$row = $branchObj->getList('branch_id',array('branch_id'=>$branch_id, 'b_type'=>2), 0, 1);
        
        //o2o门店应用
        if(app::get('o2o')->is_installed())
        {
            $storeObj = app::get('o2o')->model('store');
            $row2 = $storeObj->getList('store_id',array('branch_id'=>$branch_id), 0, 1);
        }
        
        if($row && $row2){
            return $row2[0]['store_id'];
        }else{
            return false;
        }
    }

    /*
    * 获取自有仓储对应仓库列表
    *
    * return array
    */
    public function getBranchListBywms(){
        $branchMdl = app::get('ome')->model('branch');
        $sql = "SELECT b.branch_id FROM sdb_ome_branch as b LEFT JOIN sdb_channel_adapter as a ON b.wms_id=a.channel_id WHERE a.adapter = 'selfwms' AND b.type='main' AND b.is_deliv_branch='true'";
        $rows = $branchMdl->db->select($sql);
        $branch_list = array();
        $branch_list[] = 0;
        foreach($rows as $row){
            $branch_list[] = $row['branch_id'];
        }
        return $branch_list;
    }

    /**
     *
     * 根据仓库ID获取仓库信息默认返回全部
     * @param string $branch_id 仓库ID
     * @return array
     */
    public function getBranchInfo($branch_id,$field='*'){
        $branchMdl = app::get('ome')->model('branch');
        $branch = $branchMdl->db->selectrow('select ' . $field . ' from sdb_ome_branch WHERE branch_id='.$branch_id);
        return isset($branch) ? $branch : '';
    }
}