<?php
class ome_desktop_widgets_consultandpatch implements desktop_interface_widget{

    var $order = 6;

    function __construct($app){
        $this->app = $app; 
        $this->render =  new base_render(app::get('ome'));  
    }
    
    function get_title(){
        return '';
    }

    function get_html(){
        $render = $this->render;
        $info = array();

        $info = $this->fetchDataFromCache();
        if(empty($info)){
            $result = kernel::single('base_authcode')->consultandpatch();
            $res = json_decode($result, true);
            if($res){
                if($res['code'] == 0){
                    $info = $res['data'];
                    if($info){
                        $this->saveDataToCache($info);
                    }
                }
            }
        }

        $render->pagedata['info'] = $info;
        $html = $render->fetch('desktop/widgets/consultandpatch.html');
        return $html;
    }

    function fetchDataFromCache() {
        return cachecore::fetch('consultandpatch_data');
    }

    function saveDataToCache($info) {
        cachecore::store('consultandpatch_data', $info, 1800);
    }

    function get_className(){
        return "";
    }

    function get_width(){
        return "l-3";
    }
    
}

?>