<?php
/**
 * 退换货单通知封装类
 * @author wangjianjun
 * @Time: 20170511
 */

class ome_return_notice{

    /**
     * @description 退换货单通知创建
     * @access public $reship_id 退换货ID
     * @param array $data 退换货单同步数据信息
     */
    static public function create($reship_id) {
        //获取退换货数据
        $data = kernel::single('ome_receipt_reship')->reship_create(array('reship_id'=>$reship_id));
        
        //根据仓库识别是否门店仓还是电商仓
        $store_id = kernel::single('ome_branch')->isStoreBranch($data['branch_id']);
        if($store_id){
            $channel_type = 'store';
            $channel_id = $store_id;
        }else{
            $wms_id = kernel::single('ome_branch')->getWmsIdById($data['branch_id']);
            $channel_type = 'wms';
            $channel_id = $wms_id;
        }
        
        $result = kernel::single('erpapi_router_request')->set($channel_type,$channel_id)->reship_create($data);
        
        if ($result['rsp'] == 'success' && $result['data']['wms_order_code'] && $channel_type == "wms") {
            //更新退货单外部编号  console_event_trigger_reship的update_out_bn方法
            $oReship = app::get('ome')->model('reship');
            $data = array(
                'out_iso_bn'=>$result['data']['wms_order_code'],
            );
            $oReship->update($data,array('reship_bn'=>$data['reship_bn']));
        }
        
        //记录日志
        $operationLogObj = app::get('ome')->model('operation_log');
        $rsp_result = json_encode($result);
        $memo = '发送至第三方:';
        $operationLogObj->write_log('reship@ome',$reship_id,$memo.$rsp_result);
    }

}