<?php
/**
 * 批量预占冻结库存流水记录
 * 
 * @author wangbiao<wangbiao@shopex.cn>
 * @version $2017-06-07 15:30Z
 */

$domain = $argv[1];
$order_id = $argv[2];
$host_id = $argv[3];

if (empty($domain) || empty($order_id) || empty($host_id)) {
    die('No Params');
}

set_time_limit(0);

require_once(dirname(__FILE__) . '/../../lib/init.php');

cachemgr::init(false);

$db = kernel::database();
$stockFreezeObj = app::get('material')->model('basic_material_stock_freeze');

//第一步：
echo("step 1: 正在...更新发货单对应仓库预占流水...\n\n");

//门店仓发货单
$sql    = "UPDATE sdb_material_basic_material_stock_freeze SET bill_type=1 WHERE obj_type=2 AND bill_type=0";
$db->exec($sql);

//发货单仓库流水
$page     = 0;
$limit    = 500;
$result   = delivery_add_stock_freeze();

function delivery_add_stock_freeze()
{
    global $stockFreezeObj, $page, $limit;
    
    $deliveryObj   = app::get('ome')->model('delivery');
    $dlyItemObj    = app::get('ome')->model('delivery_items');
    
    $offset   = $page * $limit;
    
    //电商仓发货单
    $filter       = array('status'=>array('progress','ready','stop'), 'process'=>'false', 'type'=>'normal', 'parent_id'=>0);
    $dataList     = $deliveryObj->getList('delivery_id, branch_id', $filter, $offset, $limit);
    if(empty($dataList))
    {
        return false;
    }
    
    foreach ($dataList as $key => $val)
    {
        $delivery_id  = $val['delivery_id'];
        
        //所属店铺
        $sql       = "SELECT b.shop_id FROM sdb_ome_delivery_order AS a LEFT JOIN sdb_ome_orders AS b ON a.order_id=b.order_id WHERE a.delivery_id=". $delivery_id;
        $tempInfo  = $deliveryObj->db->selectrow($sql);
        $shop_id   = $tempInfo['shop_id'];
        
        //明细
        $items        = $dlyItemObj->getlist('item_id, product_id, number',array('delivery_id'=>$delivery_id));
        if(empty($items))
        {
            continue;
        }
        
        //增加预占流水
        $obj_type     = 2;
        $obj_id       = $delivery_id;
        $bmsq_id      = -1;
        $bill_type    = 1;
        $branch_id    = $val['branch_id'];
        
        foreach($items as $item )
        {
            $save_data    = array(
                    'bm_id'=>$item['product_id'],
                    'obj_type'=>$obj_type,
                    'obj_id'=>$obj_id,
                    'bmsq_id'=>$bmsq_id,
                    'bill_type'=>$bill_type,
                    'shop_id'=>$shop_id,
                    'branch_id'=>$branch_id,
                    'num'=>$item['number'],
                    'create_time'=>time(),
                    'last_modified'=>time(),
            );
            
            $stockFreezeObj->insert($save_data);
        }
    }
    
    unset($dataList, $tempInfo, $items, $save_data);
    
    $page++;
    usleep(500000);#暂停0.5秒
    
    #递归调用
    delivery_add_stock_freeze();
}

//第二步：
echo("step 2: 正在...创建售后换货预占冻结流水...\n\n");

$reshipObj    = app::get('ome')->model('reship');
$dataList     = $reshipObj->getList('reship_id, order_id, changebranch_id', array('return_type'=>'change', 'is_check'=>array('1', '11'), 'status'=>'ready'));
if($dataList)
{
    $reshipLib    = kernel::single('console_reship');
    
    foreach ($dataList as $key => $val)
    {
        $reship_id  = $val['reship_id'];
        $items      = $reshipLib->change_items($reship_id);
        if(empty($items))
        {
            continue;
        }
        
        //增加预占流水
        $obj_type     = 2;
        $obj_id       = $reship_id;
        $bmsq_id      = -1;
        $bill_type    = 2;
        $shop_id      = '';
        $branch_id    = $val['changebranch_id'];
        
        foreach($items as $item )
        {
            $save_data    = array(
                    'bm_id'=>$item['product_id'],
                    'obj_type'=>$obj_type,
                    'obj_id'=>$obj_id,
                    'bmsq_id'=>$bmsq_id,
                    'bill_type'=>$bill_type,
                    'shop_id'=>$shop_id,
                    'branch_id'=>$branch_id,
                    'num'=>$item['num'],
                    'create_time'=>time(),
                    'last_modified'=>time(),
            );
            
            $stockFreezeObj->insert($save_data);
        }
    }
}


//第三步：
echo("step 3: 正在...创建采购退货预占冻结流水...\n\n");

$purchaseObj  = app::get('purchase')->model('returned_purchase');
$dataList     = $purchaseObj->getList('rp_id, branch_id', array('rp_type'=>'eo', 'return_status'=>array('1', '4'), 'check_status'=>'2'));
if($dataList)
{
    $returned_itemsObj    = app::get('purchase')->model('returned_purchase_items');
    
    foreach ($dataList as $key => $val)
    {
        $rp_id      = $val['rp_id'];
        $items      = $returned_itemsObj->getlist('bn,product_id,num',array('rp_id'=>$rp_id));
        if(empty($items))
        {
            continue;
        }
        
        //增加预占流水
        $obj_type     = 2;
        $obj_id       = $rp_id;
        $bmsq_id      = -1;
        $bill_type    = 3;
        $shop_id      = '';
        $branch_id    = $val['branch_id'];
        
        foreach($items as $item)
        {
            $save_data    = array(
                    'bm_id'=>$item['product_id'],
                    'obj_type'=>$obj_type,
                    'obj_id'=>$obj_id,
                    'bmsq_id'=>$bmsq_id,
                    'bill_type'=>$bill_type,
                    'shop_id'=>$shop_id,
                    'branch_id'=>$branch_id,
                    'num'=>$item['num'],
                    'create_time'=>time(),
                    'last_modified'=>time(),
            );
            
            $stockFreezeObj->insert($save_data);
        }
        
    }
}

//第四步：
echo("step 4: 正在...创建调拨出库预占冻结流水...\n\n");

$isoObj    = app::get('taoguaniostockorder')->model('iso');
$dataList  = $isoObj->getList('iso_id, branch_id', array('check_status'=>'2', 'iso_status'=>array('1', '2'), 'type_id'=>array('5','7','100','300','40')));
if($dataList)
{
    $oIso_items = app::get('taoguaniostockorder')->model('iso_items');
    
    foreach ($dataList as $key => $val)
    {
        $iso_id  = $val['iso_id'];
        $items   = $oIso_items->getlist('bn,nums,product_id',array('iso_id'=>$iso_id));
        if(empty($items))
        {
            continue;
        }
        
        //增加预占流水
        $obj_type     = 2;
        $obj_id       = $iso_id;
        $bmsq_id      = -1;
        $bill_type    = 4;
        $shop_id      = '';
        $branch_id    = $val['branch_id'];
        
        foreach($items as $item)
        {
            $save_data    = array(
                    'bm_id'=>$item['product_id'],
                    'obj_type'=>$obj_type,
                    'obj_id'=>$obj_id,
                    'bmsq_id'=>$bmsq_id,
                    'bill_type'=>$bill_type,
                    'shop_id'=>$shop_id,
                    'branch_id'=>$branch_id,
                    'num'=>$item['nums'],
                    'create_time'=>time(),
                    'last_modified'=>time(),
            );
            
            $stockFreezeObj->insert($save_data);
        }
    }
}


//第五步：
echo("step 5: 正在...创建库内转储预占冻结流水...\n\n");

$stockdumpObj    = app::get('console')->model('stockdump');
$dataList        = $stockdumpObj->getList('stockdump_id, from_branch_id', array('confirm_type'=>'1', 'self_status'=>'1', 'in_status'=>'0'));
if($dataList)
{
    $stockdumpItemsObj    = app::get('console')->model('stockdump_items');
    
    foreach ($dataList as $key => $val)
    {
        $stockdump_id  = $val['stockdump_id'];
        $items         = $stockdumpItemsObj->getlist('product_id, num',array('stockdump_id'=>$stockdump_id));
        if(empty($items))
        {
            continue;
        }
        
        //增加预占流水
        $obj_type     = 2;
        $obj_id       = $stockdump_id;
        $bmsq_id      = -1;
        $bill_type    = 5;
        $shop_id      = '';
        $branch_id    = $val['from_branch_id'];
        
        foreach($items as $item)
        {
            $save_data    = array(
                    'bm_id'=>$item['product_id'],
                    'obj_type'=>$obj_type,
                    'obj_id'=>$obj_id,
                    'bmsq_id'=>$bmsq_id,
                    'bill_type'=>$bill_type,
                    'shop_id'=>$shop_id,
                    'branch_id'=>$branch_id,
                    'num'=>$item['num'],
                    'create_time'=>time(),
                    'last_modified'=>time(),
            );
            
            $stockFreezeObj->insert($save_data);
        }
    }
}

//第六步：
echo("step 6: 正在...创建唯品会出库预占冻结流水...\n\n");

$stockoutObj    = app::get('purchase')->model('pick_stockout_bills');
$dataList       = $stockoutObj->getList('stockout_id, branch_id', array('status'=>1, 'confirm_status'=>2));
if($dataList)
{
    foreach ($dataList as $key => $val)
    {
        $stockout_id  = $val['stockout_id'];
        
        $sql    = "SELECT a.stockout_item_id, a.bn, a.num, b.bm_id AS product_id FROM sdb_purchase_pick_stockout_bill_items AS a 
                   LEFT JOIN sdb_material_basic_material AS b ON a.bn=b.material_bn WHERE a.stockout_id=". $stockout_id;
        $items  = $stockoutObj->db->select($sql);
        if(empty($items))
        {
            continue;
        }
        
        //增加预占流水
        $obj_type     = 2;
        $obj_id       = $stockout_id;
        $bmsq_id      = -1;
        $bill_type    = 6;
        $shop_id      = '';
        $branch_id    = $val['branch_id'];
        
        foreach($items as $item)
        {
            $save_data    = array(
                    'bm_id'=>$item['product_id'],
                    'obj_type'=>$obj_type,
                    'obj_id'=>$obj_id,
                    'bmsq_id'=>$bmsq_id,
                    'bill_type'=>$bill_type,
                    'shop_id'=>$shop_id,
                    'branch_id'=>$branch_id,
                    'num'=>$item['num'],
                    'create_time'=>time(),
                    'last_modified'=>time(),
            );
            
            $stockFreezeObj->insert($save_data);
        }
    }
}


echo("...End, Execute Success...\n\n");


/**
 * 日志
 */
function ilog($str) {
    global $domain;
    $filename = dirname(__FILE__) . '/../logs/batchconsign' . date('Y-m-d') . '.log';
    $fp = fopen($filename, 'a');
    fwrite($fp, date("m-d H:i") . "\t" . $domain . "\t" . $str . "\n");
    fclose($fp);
}