<?php
/**
 * [重算]基础物料对应所有订单的店铺冻结记录
 * 
 * @author: wangbiao@shopex.cn
 */
error_reporting(E_ALL ^ E_NOTICE);

$domain = $argv[1];
$order_id = $argv[2];
$host_id = $argv[3];

if (empty($domain) || empty($order_id) || empty($host_id)) {
    die('No Params');
}

set_time_limit(0);
require_once(dirname(__FILE__) . '/../../lib/init.php');
cachemgr::init(false);

$db                      = kernel::database();
$basicMStockFreezeLib    = kernel::single('material_basic_material_stock_freeze');


//全渠道订单必须是已发货状态
$o2o_corp_ids   = array();
$corpObj        = app::get('ome')->model('dly_corp');
$corp_info      = $corpObj->getList('corp_id', array('d_type'=>2));
foreach ($corp_info as $key => $val)
{
    $o2o_corp_ids[]    = $val['corp_id'];
}

if($o2o_corp_ids)
{
    $sql    = "SELECT count(*) AS num FROM sdb_ome_orders 
               WHERE process_status='splited' AND ship_status='0' AND status='active' AND logi_id in(". implode(',', $o2o_corp_ids) .")";
    $order_count    = $db->selectrow($sql);
    if($order_count['num'])
    {
        echo('Warning: There are o2o orders not shipped...');
        exit;
    }
}


$total   = 0;
$succ    = 0;
$fail    = 0;

$page     = 0;#开始页
$limit    = 500;#每次执行数量


//[初始化]删除基础物料预占记录
$sql    = "DELETE FROM sdb_material_basic_material_stock_freeze WHERE 1 AND obj_type=1";
$db->exec($sql);

//开始执行
$result    = batch_basic_material_stock_freeze();

ilog('批量更新销售物料店铺冻结已完成', true);


/**
 * 基础物料对应所有订单的店铺冻结记录
 * 
 * @return boolean
 */
function batch_basic_material_stock_freeze()
{
    global $db, $page, $limit, $fail, $basicMStockFreezeLib;
    
    #查询
    $sql    = "SELECT o.order_id, o.shop_id, o.process_status, i.item_id, i.product_id, i.nums, i.sendnum 
               FROM sdb_ome_orders AS o LEFT JOIN sdb_ome_order_items AS i ON o.order_id=i.order_id 
               WHERE o.process_status in ('unconfirmed', 'confirmed', 'is_retrial', 'is_declare', 'splitting') 
               AND o.status='active' AND i.`delete`='false' AND i.nums > i.sendnum LIMIT ". ($page * $limit) .", " . $limit;
    $dataList    = $db->select($sql);
    
    #没有可执行的货品,则退出.
    if(empty($dataList))
    {
        return false;
    }
    
    #加入事务
    $db->beginTransaction();
    
    foreach ($dataList as $key => $val)
    {
        #部分拆分时_直接减去发货单上货品数量
        $num    = 0;
        if($val['process_status'] == 'splitting')
        {
            $dly_sql        = "SELECT SUM(number) AS num FROM `sdb_ome_delivery_items_detail` AS did 
                               JOIN `sdb_ome_delivery` AS d ON d.delivery_id=did.delivery_id 
                               WHERE did.order_item_id='". $val['item_id'] ."' AND did.product_id='". $val['product_id'] ."' 
                               AND d.status NOT IN('back', 'cancel', 'return_back') AND d.is_bind='false'";
            $dly_num    = $db->selectrow($dly_sql);
            $num        = intval($val['nums'] - $dly_num['num']);
        }
        else 
        {
            $num    = $val['nums'] - $val['sendnum'];//未拆分数量
        }
        
        $result = $basicMStockFreezeLib->freeze($val['product_id'], 1, 0, $val['order_id'], $val['shop_id'], 0, -1, $num);
        
        if(!$result)
        {
            $db->rollBack();
            
            $fail++;
            ilog('执行失败...bm_id:'. $val['product_id'], false);
            
            echo('Warning: UPDATE sdb_material_basic_material_stock_freeze...Error...');
            exit;
        }
    }
    
    #提交事务
    $db->commit();
    
    #release
    unset($dataList, $sql, $result);
    
    $page++;
    usleep(1000000);#暂停一秒
    
    #递归调用
    batch_basic_material_stock_freeze();
}

/**
 * 日志
 */
function ilog($str, $flag = false)
{
    global $domain;
    $filename = dirname(__FILE__) . '/../logs/recount_basic_material_stock_freeze_' . date('Y-m-d') . '.log';
    
    if($flag)
    {
        $filename = dirname(__FILE__) . '/../logs/recount_basic_material_stock_freeze_' . date('Y-m-d') . '.log';
    }
    
    $fp = fopen($filename, 'a');
    fwrite($fp, date("m-d H:i") . "\t" . $domain . "\t" . $str . "\n");
    fclose($fp);
}
